/* Copyright (c) 2005 ACM/SIGDA
   Prepared by Geert Janssen, geert@us.ibm.com

   You only need to complete 2 functions in this file.
   These functions are clearly marked by the text

   YOU NEED TO IMPLEMENT THIS BODY !!!

   as a comment in their body. But feel free to change anything else
   if you think it suits you better.

   Good luck.
*/

#include "parser.h"

/*#define DEBUG*/

/* Normalizes tree t by re-expressing its Boolean function in terms of
   NAND and NOT gates only. Returns the newly constructed tree.
*/
static Tree
tree_normalize(Tree t)
{

  /* YOU NEED TO IMPLEMENT THIS BODY !!! */

  /* Dummy return value for now: */
  return NULL;
}

/* Returns the size of the tree t. */
static int
tree_size(Tree t)
{
  /* YOU NEED TO IMPLEMENT THIS BODY !!! */

  /* Dummy return value for now: */
  return 0;
}

/* --------------------------------------------------------------------------*/
/*			    Main					     */
/* --------------------------------------------------------------------------*/

int
main(int argc, char *argv[])
{
  Tree s, t;

  if (argc > 1 && argv[1])
    if (!freopen(argv[1], "r", stdin)) {
      fprintf(stderr, "Error: Cannot open file %s\n", argv[1]);
      exit(EXIT_FAILURE);
    }

  t = parse();

#ifdef DEBUG
  printf("Input tree circuit: ");
  tree_print(t);
  printf("\n");
#endif

  printf("%d\n", tree_size(t));

  t = tree_normalize(s = t);
  tree_free(s);

#ifdef DEBUG
  printf("Normalized tree   : ");
  tree_print(t);
  printf("\n");
#endif

  printf("%d\n", tree_size(t));

  tree_free(t);

  return EXIT_SUCCESS;
}
