/* quick and dirty program to plot the frequency response */

#include <stdio.h>
#include <math.h>

#define MAXLEN 100

double coef[MAXLEN];

int main(int argc, char *argv[])
{
     int ncoef = 0;
     double f;
     
     while (scanf("%lg", &coef[ncoef]) == 1)
	  ++ncoef;

     for (f = 0; f < .5; f += .5 / 1024) {
	  double r = 0, i = 0;
	  int n;
	  
	  for (n = 0; n < ncoef; ++n) {
	       r += coef[n] * cos(2 * M_PI * n * f);
	       i += coef[n] * sin(2 * M_PI * n * f);
	  }

	  printf("%g %g\n", 2*M_PI*f, sqrt(r * r + i * i));
     }
     return 0;
}
   
